/****************************************************************************
 * Grafik-LCD Treiber mit VRAM.
 *
 * (C) Andreas Kaiser 2008.
 *
 * Die Software darf frei kopiert und verndert werden, solange sie
 * nicht ohne meine ausdrckliche Erlaubnis fr kommerzielle Zwecke
 * eingesetzt wird.
 ****************************************************************************/

#ifndef __GBASE_H
#define __GBASE_H

#include "graph.h"

#define LCD_WORDS	(LCD_COLS/LCD_BITS)

typedef struct {
    uint8_t	height;
    uint8_t	width;
    prog_uchar *data;	// NULL:softfont
} g_font_t;

uint8_t		g_bitmask[4];
uint8_t		g_setmask[4];

uint8_t		g_read (vram_row_t row, vram_col_t col);
void		g_write (vram_row_t row, vram_col_t col, g_op op, uint8_t mask, uint8_t data);

#define swap(a,b) do{ typeof(a) tmp = (a); (a) = (b); (b) = tmp; }while(0)

static uint16_t __inline__
umul8x8(uint8_t x, uint8_t y)
{
    unsigned result;
    asm ("mul	%1, %2\n\t"
	 "movw	%0, r0\n\t"
	 "clr	r1"
	 : "=r"(result)
	 : "r"(x), "r"(y)
	 : "r0", "cc");
    return result;
}

static int16_t __inline__
smul8x8(int8_t x, int8_t y)
{
    unsigned result;
    asm ("muls	%1, %2\n\t"
	 "movw	%0, r0\n\t"
	 "clr	r1"
	 : "=r"(result)
	 : "d"(x), "d"(y)
	 : "r0", "cc");
    return result;
}

#endif //__GBASE_H
